//! `SeaORM` Entity, @generated by sea-orm-codegen 1.1.0

use super::sea_orm_active_enums::DnsProvider;
use sea_orm::entity::prelude::*;

#[derive(Clone, Debug, PartialEq, DeriveEntityModel, Eq)]
#[sea_orm(table_name = "Domain")]
pub struct Model {
    #[sea_orm(column_type = "Text")]
    pub name: String,
    #[sea_orm(column_name = "createdAt")]
    pub created_at: DateTime,
    #[sea_orm(column_name = "providerAuth", column_type = "Text", nullable)]
    pub provider_auth: Option<String>,
    #[sea_orm(primary_key, auto_increment = false)]
    pub id: Uuid,
    pub provider: DnsProvider,
    #[sea_orm(column_name = "ownerName", column_type = "Text")]
    pub owner_name: String,
}

#[derive(Copy, Clone, Debug, EnumIter, DeriveRelation)]
pub enum Relation {
    #[sea_orm(has_many = "super::app_domain::Entity")]
    AppDomain,
    #[sea_orm(has_many = "super::proxy::Entity")]
    Proxy,
    #[sea_orm(
        belongs_to = "super::user::Entity",
        from = "Column::OwnerName",
        to = "super::user::Column::Username",
        on_update = "Cascade",
        on_delete = "Restrict"
    )]
    User,
}

impl Related<super::app_domain::Entity> for Entity {
    fn to() -> RelationDef {
        Relation::AppDomain.def()
    }
}

impl Related<super::proxy::Entity> for Entity {
    fn to() -> RelationDef {
        Relation::Proxy.def()
    }
}

impl Related<super::user::Entity> for Entity {
    fn to() -> RelationDef {
        Relation::User.def()
    }
}

impl ActiveModelBehavior for ActiveModel {}
